var xpunge_mu_consoleService = Components.classes['@mozilla.org/consoleservice;1']
		.getService(Components.interfaces.nsIConsoleService);

var xpunge_mu_prefBranch = Components.classes["@mozilla.org/preferences-service;1"]
		.getService(Components.interfaces.nsIPrefBranch);

var xpunge_mu_TRASH_SEPARATOR_REGEXP = /   /;
var xpunge_mu_JUNK_SEPARATOR_REGEXP = /   /;
var xpunge_mu_COMPACT_SEPARATOR_REGEXP = /   /;

function xpunge_doMultiple() {
	var msg = "xpunge - xpunge_doMultiple: " + new Date() + "\n\n";

	if (!messenger) {
		xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_doMultiple:" + "\n\n"
				+ "ERROR - No Messenger Object!" + "\n");

		return;
	}

	var confirmAction = xpunge_mu_prefBranch.getBoolPref("extensions.xpunge.settings.multi.confirm");

	if (confirmAction) {
		var proceed = xpunge_mu_proceedWith();

		if (!proceed) {
			return;
		}
	}

	msg = msg + xpunge_mu_processJunk();

	msg = msg + xpunge_mu_processTrash();

	msg = msg + xpunge_mu_processCompact();

	xpunge_mu_consoleService.logStringMessage(msg);
}

function xpunge_mu_processTrash() {
	var returnedMsg = "";

	var pref_trash = xpunge_mu_prefBranch.getCharPref("extensions.xpunge.multi.trash.accounts");

	if (pref_trash !== "") {
		var trash_array = pref_trash.split(xpunge_mu_TRASH_SEPARATOR_REGEXP);

		for (var i = 0; i < trash_array.length; i++) {
			if (trash_array[i] === "") {
				xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_doMultiple:" + "\n\n"
						+ "ERROR - Empty Trash Account Entry: Index = " + i + "\n");

				continue;
			}

			var msgfolder = xpunge_GetMsgFolderFromUri(trash_array[i], true);

			if (!msgfolder) {
				xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_doMultiple:" + "\n\n"
						+ "ERROR - Invalid Trash Account: " + trash_array[i] + "\n");

				continue;
			}

			if (!msgfolder.isServer) {
				xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_doMultiple:" + "\n\n"
						+ "ERROR - Trash Account Is Not A Server: " + trash_array[i] + "\n");

				continue;
			}

			if (msgfolder.name === "") {
				xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_doMultiple:" + "\n\n"
						+ "WARNING - Trash Account Has No Name: " + trash_array[i] + "\n");

				continue;
			}

			try {
				if (xpunge_canEmptyTrashMulti(msgfolder)) {
					returnedMsg = returnedMsg + "Emptying Trash For Account: " + msgfolder.prettyName + "\n";

					gFolderTreeController.emptyTrash(msgfolder);
				}
			} catch (e) {
				xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_doMultiple EXCEPTION 1 ["
						+ new Date() + "]: " + "\n\n" + trash_array[i] + "\n\n" + e + "\n");
			}
		}
	}

	return returnedMsg;
}

function xpunge_mu_processJunk() {
	var returnedMsg = "";

	var pref_junk = xpunge_mu_prefBranch.getCharPref("extensions.xpunge.multi.junk.accounts");

	if (pref_junk !== "") {
		var junk_array = pref_junk.split(xpunge_mu_JUNK_SEPARATOR_REGEXP);

		for (var i = 0; i < junk_array.length; i++) {
			if (junk_array[i] === "") {
				xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_doMultiple:" + "\n\n"
						+ "ERROR - Empty Junk Account Entry: Index = " + i + "\n");

				continue;
			}

			var msgfolder = xpunge_GetMsgFolderFromUri(junk_array[i], true);

			if (!msgfolder) {
				xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_doMultiple:" + "\n\n"
						+ "ERROR - Invalid Junk Account: " + junk_array[i] + "\n");

				continue;
			}

			if (!msgfolder.isServer) {
				xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_doMultiple:" + "\n\n"
						+ "ERROR - Junk Account Is Not A Server: " + junk_array[i] + "\n");

				continue;
			}

			if (msgfolder.name === "") {
				xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_doMultiple:" + "\n\n"
						+ "WARNING - Junk Account Has No Name: " + junk_array[i] + "\n");

				continue;
			}

			try {
				if (xpunge_canEmptyJunkMulti(msgfolder)) {
					returnedMsg = returnedMsg + xpunge_emptyJunkMulti(msgfolder);
				}
			} catch (e) {
				xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_doMultiple EXCEPTION 2 ["
						+ new Date() + "]: " + "\n\n" + junk_array[i] + "\n\n" + e + "\n");
			}
		}
	}

	return returnedMsg;
}

function xpunge_emptyJunkMulti(folder) {
	var returnedMsg = "";

	// This will discover all folders considered to be "junk". For example, in an IMAP Gmail account
	// it will be both Gmail's "Spam" folder and the "Junk" folder created by Thunderbird if the user 
	// chooses to send emails marked as spam there.
	var junkFolders = folder.rootFolder.getFoldersWithFlags(nsMsgFolderFlags.Junk);

	for (var junkFolder in fixIterator(junkFolders.enumerate(), Components.interfaces.nsIMsgFolder)) {
		try {
			if (junkFolder.getTotalMessages(true) > 0) {
				returnedMsg = returnedMsg + "Emptying Junk Folder (" + junkFolder.prettyName + ") For Account: "
						+ folder.prettyName + "\n";
				gFolderTreeController.emptyJunk(junkFolder);
			} else {
				xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_doMultiple: " + new Date() + "\n\n"
						+ "Avoiding To Empty Already " 
						+ "Empty Junk Folder (" + junkFolder.prettyName + ") For Account: " 
						+ folder.prettyName + "\n");
			}
		} catch (e) {
			xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_doMultiple EXCEPTION 4 [" + new Date()
					+ "]:" + "\n\nJunk Folder: " + junkFolder.URI + "\n\n" + e + "\n");
		}
	}

	return returnedMsg;
}

function xpunge_mu_processCompact() {
	var returnedMsg = "";

	var pref_compact = xpunge_mu_prefBranch.getCharPref("extensions.xpunge.multi.compact.accounts");

	if (pref_compact !== "") {
		var compact_array = pref_compact.split(xpunge_mu_COMPACT_SEPARATOR_REGEXP);

		for (var i = 0; i < compact_array.length; i++) {
			if (compact_array[i] === "") {
				xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_doMultiple:" + "\n\n"
						+ "ERROR - Empty Compact Account/Folder Entry: Index = " + i + "\n");

				continue;
			}

			var msgfolder = xpunge_GetMsgFolderFromUri(compact_array[i], true);

			if (!msgfolder) {
				xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_doMultiple:" + "\n\n"
						+ "ERROR - Invalid Compact Account/Folder: " + compact_array[i] + "\n");

				continue;
			}

			if (msgfolder.name === "") {
				xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_doMultiple:" + "\n\n"
						+ "WARNING - Compact Account/Folder Has No Name: " + compact_array[i] + "\n");

				continue;
			}

			try {
				if (xpunge_canCompactFoldersMulti(msgfolder)) {
					var foldersToCompact = [];
					foldersToCompact[0] = msgfolder;

					if (msgfolder.isServer) {
						returnedMsg = returnedMsg + "Compacting All Folders For Account: "
								+ msgfolder.prettyName + "\n";

						gFolderTreeController.compactAllFoldersForAccount(foldersToCompact);
					} else {
						returnedMsg = returnedMsg + "Compacting Folder (" + msgfolder.name + ") on "
								+ msgfolder.server.prettyName + "\n";

						gFolderTreeController.compactFolders(foldersToCompact);
					}
				}
			} catch (e) {
				xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_doMultiple EXCEPTION 3 ["
						+ new Date() + "]: " + "\n\n" + compact_array[i] + "\n\n" + e + "\n");
			}
		}
	}

	return returnedMsg;
}

function xpunge_canEmptyJunkMulti(folder) {
	var server = folder.server;

	if (!server) {
		xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_canEmptyJunkMulti:" + "\n\n"
				+ "ERROR - Invalid Server Property: " + folder.URI + "\n");

		return false;
	}

	var serverType = server.type;

	if (serverType == "nntp") {
		xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_canEmptyJunkMulti:" + "\n\n"
				+ "WARNING - Cannot Empty Junk On An NNTP Server: " + folder.URI + "\n");

		return false;
	} else if (serverType == "imap") {
		var ioService = Components.classes["@mozilla.org/network/io-service;1"]
				.getService(Components.interfaces.nsIIOService);

		if (ioService.offline) {
			xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_canEmptyJunkMulti:" + "\n\n"
					+ "WARNING - Cannot Empty Junk On An IMAP Server While Being Offline: " + folder.URI
					+ "\n");

			return false;
		}

		return true;
	} else {
		return true;
	}
}

function xpunge_canEmptyTrashMulti(folder) {
	var server = folder.server;

	if (!server) {
		xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_canEmptyTrashMulti:" + "\n\n"
				+ "ERROR - Invalid Server Property: " + folder.URI + "\n");

		return false;
	}

	var serverType = server.type;

	if (serverType == "nntp") {
		xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_canEmptyTrashMulti:" + "\n\n"
				+ "WARNING - Cannot Empty Trash On An NNTP Server: " + folder.URI + "\n");

		return false;
	} else if (serverType == "imap") {
		var ioService = Components.classes["@mozilla.org/network/io-service;1"]
				.getService(Components.interfaces.nsIIOService);

		if (ioService.offline) {
			xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_canEmptyTrashMulti:" + "\n\n"
					+ "WARNING - Cannot Empty Trash On An IMAP Server While Being Offline: " + folder.URI
					+ "\n");

			return false;
		}

		return true;
	} else {
		return true;
	}
}

function xpunge_canCompactFoldersMulti(folder) {
	var server = folder.server;

	if (!server) {
		xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_canCompactFoldersMulti:" + "\n\n"
				+ "ERROR - Invalid Server Property: " + folder.URI + "\n");

		return false;
	}

	if (folder.isServer) {
		if (!server.canCompactFoldersOnServer) {
			xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_canCompactFoldersMulti:" + "\n\n"
					+ "ERROR - Compacting Folders Not Allowed On Server: " + folder.URI + "\n");

			return false;
		}
	} else {
		if (!folder.canCompact) {
			xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_canCompactFoldersMulti:" + "\n\n"
					+ "ERROR - Compacting Folder Not Allowed: " + folder.URI + "\n");

			return false;
		}
	}

	var serverType = server.type;

	if (serverType == "imap") {
		var ioService = Components.classes["@mozilla.org/network/io-service;1"]
				.getService(Components.interfaces.nsIIOService);

		if (ioService.offline) {
			xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_canCompactFoldersMulti:" + "\n\n"
					+ "WARNING - Cannot Compact Folders On An IMAP Server While Being Offline: " + folder.URI
					+ "\n");

			return false;
		}

		return true;
	} else {
		return true;
	}
}

function xpunge_mu_doMenuActionCall(elem) {
	xpunge_doMultiple();
}

function xpunge_mu_proceedWith() {
	var stringBundle = Components.classes["@mozilla.org/intl/stringbundle;1"]
			.getService(Components.interfaces.nsIStringBundleService)
			.createBundle("chrome://xpunge/locale/xpunge_strings.properties");

	var trashSettings = xpunge_mu_calculateTrashSettings();
	var junkSettings = xpunge_mu_calculateJunkSettings();
	var compactSettings = xpunge_mu_calculateCompactSettings(stringBundle);

	// get a reference to the prompt service component.
	var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
			.getService(Components.interfaces.nsIPromptService);

	var dialogTitle = stringBundle.GetStringFromName("xpunge_multi_str_confirm_dialog_title");

	var dialogMsg = stringBundle.formatStringFromName("xpunge_multi_str_confirm_msg_body", [ trashSettings,
			junkSettings, compactSettings ], 3);

	// Show a confirmation dialog. For the first argument, supply the parent window. The second
	// argument is the dialog title and the third argument is the message to display.
	return promptService.confirm(window, dialogTitle, dialogMsg);
}

function xpunge_mu_calculateTrashSettings() {
	var trashSettings = "";

	var pref_trash = xpunge_mu_prefBranch.getCharPref("extensions.xpunge.multi.trash.accounts");

	if (pref_trash !== "") {
		var trash_array = pref_trash.split(xpunge_mu_TRASH_SEPARATOR_REGEXP);

		var msgfolder;

		for (var i = 0; i < trash_array.length - 1; i++) {
			msgfolder = xpunge_GetMsgFolderFromUri(trash_array[i], true);
			trashSettings = trashSettings + msgfolder.prettyName + ", ";
		}

		if ((trash_array.length - 1) >= 0) {
			msgfolder = xpunge_GetMsgFolderFromUri(trash_array[trash_array.length - 1], true);
			trashSettings = trashSettings + msgfolder.prettyName + ".";
		}
	}

	return trashSettings;
}

function xpunge_mu_calculateJunkSettings() {
	var junkSettings = "";

	var pref_junk = xpunge_mu_prefBranch.getCharPref("extensions.xpunge.multi.junk.accounts");

	if (pref_junk !== "") {
		var junk_array = pref_junk.split(xpunge_mu_JUNK_SEPARATOR_REGEXP);

		var msgfolder;

		for (var i = 0; i < junk_array.length - 1; i++) {
			msgfolder = xpunge_GetMsgFolderFromUri(junk_array[i], true);
			junkSettings = junkSettings + msgfolder.prettyName + ", ";
		}

		if ((junk_array.length - 1) >= 0) {
			msgfolder = xpunge_GetMsgFolderFromUri(junk_array[junk_array.length - 1], true);
			junkSettings = junkSettings + msgfolder.prettyName + ".";
		}
	}

	return junkSettings;
}

function xpunge_mu_calculateCompactSettings(stringBundle) {
	var compactSettings = "";

	var pref_compact = xpunge_mu_prefBranch.getCharPref("extensions.xpunge.multi.compact.accounts");

	if (pref_compact !== "") {
		var compact_array = pref_compact.split(xpunge_mu_COMPACT_SEPARATOR_REGEXP);

		var msgfolder;

		for (var i = 0; i < compact_array.length - 1; i++) {
			msgfolder = xpunge_GetMsgFolderFromUri(compact_array[i], true);

			if (msgfolder.isServer) {
				compactSettings = compactSettings + msgfolder.prettyName + " "
						+ stringBundle.GetStringFromName("xpunge_multi_str_compact_whole") + ", ";
			} else {
				compactSettings = compactSettings + msgfolder.prettyName + " "
						+ stringBundle.GetStringFromName("xpunge_multi_str_compact_belongs") + " "
						+ msgfolder.server.prettyName + ", ";
			}
		}

		if ((compact_array.length - 1) >= 0) {
			msgfolder = xpunge_GetMsgFolderFromUri(compact_array[compact_array.length - 1], true);

			if (msgfolder.isServer) {
				compactSettings = compactSettings + msgfolder.prettyName + " "
						+ stringBundle.GetStringFromName("xpunge_multi_str_compact_whole") + ".";
			} else {
				compactSettings = compactSettings + msgfolder.prettyName + " "
						+ stringBundle.GetStringFromName("xpunge_multi_str_compact_belongs") + " "
						+ msgfolder.server.prettyName + ".";
			}
		}
	}

	return compactSettings;
}
